/*
 * File: MiddleRobotCtrl_mat.cpp
 *
 * Real-Time Workshop code generated for Simulink model MiddleRobotCtrl_mat.
 *
 * Model version                        : 1.36
 * Real-Time Workshop file version      : 7.4  (R2009b)  29-Jun-2009
 * Real-Time Workshop file generated on : Tue Feb 22 17:26:30 2011
 * TLC version                          : 7.4 (Jul 14 2009)
 * C/C++ source code generated on       : Tue Feb 22 17:26:31 2011
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "MiddleRobotCtrl_mat.h"
#include "MiddleRobotCtrl_mat_private.h"

/* Block states (auto storage) */
D_Work_MiddleRobotCtrl_mat MiddleRobotCtrl_mat_DWork;

/* External inputs (root inport signals with auto storage) */
ExternalInputs_MiddleRobotCtrl_ MiddleRobotCtrl_mat_U;

/* External outputs (root outports fed by signals with auto storage) */
ExternalOutputs_MiddleRobotCtrl MiddleRobotCtrl_mat_Y;

/* Real-time model */
RT_MODEL_MiddleRobotCtrl_mat MiddleRobotCtrl_mat_M_;
RT_MODEL_MiddleRobotCtrl_mat *MiddleRobotCtrl_mat_M = &MiddleRobotCtrl_mat_M_;

/*********************************************************************
 * Lookup Binary Search Utility BINARYSEARCH_real_T
 */
void BINARYSEARCH_real_T( uint32_T *piLeft, uint32_T *piRght, real_T u, const
  real_T *pData, uint32_T iHi)
{
  /* Find the location of current input value in the data table. */
  *piLeft = 0U;
  *piRght = iHi;
  if (u <= pData[0] ) {
    /* Less than or equal to the smallest point in the table. */
    *piRght = 0U;
  } else if (u >= pData[iHi] ) {
    /* Greater than or equal to the largest point in the table. */
    *piLeft = iHi;
  } else {
    uint32_T i;

    /* Do a binary search. */
    while (( *piRght - *piLeft ) > 1U ) {
      /* Get the average of the left and right indices using to Floor rounding. */
      i = (*piLeft + *piRght) >> 1;

      /* Move either the right index or the left index so that */
      /*  LeftDataPoint <= CurrentValue < RightDataPoint */
      if (u < pData[i] ) {
        *piRght = i;
      } else {
        *piLeft = i;
      }
    }
  }
}

/* end macro BINARYSEARCH_real_T
 *********************************************************************/

/*********************************************************************
 * Lookup Utility LookUp_real_T_real_T
 */
void LookUp_real_T_real_T( real_T *pY, const real_T *pYData, real_T u, const
  real_T *pUData, uint32_T iHi)
{
  uint32_T iLeft;
  uint32_T iRght;
  BINARYSEARCH_real_T( &(iLeft), &(iRght), u, pUData, iHi);

  {
    real_T lambda;
    if (pUData[iRght] > pUData[iLeft] ) {
      real_T num;
      real_T den;
      den = pUData[iRght];
      den = den - pUData[iLeft];
      num = u;
      num = num - pUData[iLeft];
      lambda = num / den;
    } else {
      lambda = 0;
    }

    {
      real_T yLeftCast;
      real_T yRghtCast;
      yLeftCast = pYData[iLeft];
      yRghtCast = pYData[iRght];
      if (lambda != 0) {
        yLeftCast += lambda * ( yRghtCast - yLeftCast );
      }

      (*pY) = yLeftCast;
    }
  }
}

/* end function LookUp_real_T_real_T
 *********************************************************************/

/*********************************************************************
 * Lookup 2D Lookup Utility Look2D_real_T_real_T_real_T
 */
void Look2D_real_T_real_T_real_T( real_T *pY, const real_T *pYData, real_T u0,
  const real_T *pU0Data, uint32_T iHiU0, real_T u1, const real_T *pU1Data,
  uint32_T iHiU1)
{
  uint32_T iLeftU0, iRghtU0, iLeftU1, iRghtU1;
  BINARYSEARCH_real_T( &(iLeftU0), &(iRghtU0), u0, pU0Data, iHiU0);
  BINARYSEARCH_real_T( &(iLeftU1), &(iRghtU1), u1, pU1Data, iHiU1);

  {
    real_T u0Left = pU0Data[iLeftU0];
    real_T u0Rght = pU0Data[iRghtU0];
    real_T u1Left = pU1Data[iLeftU1];
    real_T u1Rght = pU1Data[iRghtU1];
    real_T yTemp;
    real_T yLeftLeft;
    real_T yLeftRght;
    real_T yRghtLeft;
    real_T yRghtRght;
    real_T u1Lambda;
    real_T u0Lambda;
    if (u1Rght > u1Left ) {
      real_T num;
      real_T den;
      den = u1Rght;
      den = den - u1Left;
      num = u1;
      num = num - u1Left;
      u1Lambda = num / den;
    } else {
      u1Lambda = 0;
    }

    if (u0Rght > u0Left ) {
      real_T num;
      real_T den;
      den = u0Rght;
      den = den - u0Left;
      num = u0;
      num = num - u0Left;
      u0Lambda = num / den;
    } else {
      u0Lambda = 0;
    }

    iHiU0++;
    iLeftU1 *= iHiU0;
    iRghtU1 *= iHiU0;
    yRghtLeft = pYData[(iRghtU0+iLeftU1)];
    yRghtRght = pYData[(iRghtU0+iRghtU1)];
    yLeftLeft = pYData[(iLeftU0+iLeftU1)];
    yLeftRght = pYData[(iLeftU0+iRghtU1)];

    /* Interpolate along U1 variable
     *    with the u0 variable locked on the left u0
     */
    {
      real_T yLeftCast;
      real_T yRghtCast;
      yLeftCast = yLeftLeft;
      yRghtCast = yLeftRght;
      if (u1Lambda != 0) {
        yLeftCast += u1Lambda * ( yRghtCast - yLeftCast );
      }

      (*pY) = yLeftCast;
    }

    /* Interpolate along U1 variable
     *    with the u0 variable locked on the right u0
     */
    {
      real_T yLeftCast;
      real_T yRghtCast;
      yLeftCast = yRghtLeft;
      yRghtCast = yRghtRght;
      if (u1Lambda != 0) {
        yLeftCast += u1Lambda * ( yRghtCast - yLeftCast );
      }

      yTemp = yLeftCast;
    }

    /*
     * Interpolate along u0 variable
     *    with the u1 variable locked on its interpolated value
     */
    {
      real_T yLeftCast;
      real_T yRghtCast;
      yLeftCast = (*pY);
      yRghtCast = yTemp;
      if (u0Lambda != 0) {
        yLeftCast += u0Lambda * ( yRghtCast - yLeftCast );
      }

      (*pY) = yLeftCast;
    }
  }
}

/* end function Look2D_real_T_real_T_real_T
 *********************************************************************/

/* Model step function */
void MiddleRobotCtrl_mat_step(void)
{
  /* local block i/o variables */
  real_T rtb_MathFunction2_i;
  real_T rtb_LookupTable;
  real_T rtb_LookupTable1;
  real_T rtb_LookupTable1_c;
  real_T rtb_LookupTable_l;
  real_T rtb_LookupTable2D;
  real_T rtb_LookupTable2D_d;
  real_T rtb_LookupTable2D_b;
  real_T rtb_LookupTable2D_h;
  real_T rtb_MathFunction1_k;
  real_T rtb_MathFunction2_p;
  real_T rtb_MathFunction2_g;
  real_T rtb_MathFunction2_gx;
  real_T rtb_MathFunction2_f;
  real_T rtb_Switch_d;

  {
    real_T rtb_IntegerDelay;
    uint8_T rtb_Compare;
    real_T rtb_SwitchControl;
    boolean_T rtb_Compare_lu;
    boolean_T rtb_Compare_fkd;
    boolean_T rtb_Compare_o3;
    boolean_T rtb_Compare_g;
    boolean_T rtb_Compare_h;
    boolean_T rtb_Compare_ik;
    boolean_T rtb_Compare_hp;
    boolean_T rtb_Compare_e;
    boolean_T rtb_Compare_fr;
    uint16_T rtb_LogicalOperator_ig;
    real_T rtb_Saturation_p;
    real_T rtb_Saturation;
    real_T rtb_MathFunction2;
    boolean_T rtb_Compare_ft;
    int16_T rtb_LogicalOperator1;
    real_T rtb_Add1;
    real_T rtb_Add2;
    real_T rtb_Switch1;
    real_T rtb_Add3;
    real_T rtb_Add4;
    real_T rtb_Relay;
    real_T rtb_pos_k_idx;
    real_T rtb_pos_k_idx_0;

    /* S-Function (sfix_udelay): '<S2>/Integer Delay' */
    rtb_IntegerDelay = MiddleRobotCtrl_mat_DWork.IntegerDelay_X[0];

    /* RelationalOperator: '<S5>/Compare' incorporates:
     *  Sum: '<S6>/Diff'
     *  UnitDelay: '<S6>/UD'
     */
    rtb_Compare = (MiddleRobotCtrl_mat_DWork.IntegerDelay_X[0] -
                   MiddleRobotCtrl_mat_DWork.UD_DSTATE != 0.0);

    /* DigitalClock: '<S21>/Digital Clock' */
    rtb_Switch_d = (((MiddleRobotCtrl_mat_M->Timing.clockTick0+
                      MiddleRobotCtrl_mat_M->Timing.clockTickH0* 4294967296.0)) *
                    0.1);

    /* Switch: '<S21>/Switch2' incorporates:
     *  Constant: '<S21>/Constant2'
     *  Constant: '<S77>/Constant'
     *  Constant: '<S78>/Constant'
     *  Logic: '<S21>/Logical Operator2'
     *  RelationalOperator: '<S77>/Compare'
     *  RelationalOperator: '<S78>/Compare'
     *  UnitDelay: '<S3>/Unit Delay'
     */
    if (((rtb_Switch_d <= MiddleRobotCtrl_mat_P.Constant_Value) != 0) &&
        ((MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE ==
          MiddleRobotCtrl_mat_P.Constant_Value_p) != 0)) {
      rtb_Switch_d = MiddleRobotCtrl_mat_P.Constant2_Value_o;
    } else {
      /* Switch: '<S21>/Switch1' incorporates:
       *  Constant: '<S21>/Constant1'
       *  Constant: '<S76>/Constant'
       *  Constant: '<S79>/Constant'
       *  Constant: '<S80>/Constant'
       *  Constant: '<S81>/Constant'
       *  Inport: '<Root>/ObjectInfo'
       *  Inport: '<Root>/OrderInfo'
       *  Logic: '<S21>/Logical Operator3'
       *  Logic: '<S21>/Logical Operator4'
       *  Logic: '<S21>/Logical Operator5'
       *  RelationalOperator: '<S76>/Compare'
       *  RelationalOperator: '<S79>/Compare'
       *  RelationalOperator: '<S80>/Compare'
       *  RelationalOperator: '<S81>/Compare'
       *  UnitDelay: '<S3>/Unit Delay'
       */
      if ((MiddleRobotCtrl_mat_U.ObjectInfo[6] ==
           MiddleRobotCtrl_mat_P.Constant_Value_hg) ||
          ((((MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE >=
              MiddleRobotCtrl_mat_P.Constant_Value_l) != 0) ||
            ((MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE <=
              MiddleRobotCtrl_mat_P.Constant_Value_g) != 0)) &&
           (MiddleRobotCtrl_mat_U.OrderInfo ==
            MiddleRobotCtrl_mat_P.Constant_Value_jao))) {
        rtb_Switch_d = MiddleRobotCtrl_mat_P.Constant1_Value_m;
      } else {
        /* Switch: '<S21>/Switch' incorporates:
         *  Constant: '<S21>/Constant'
         *  Constant: '<S74>/Constant'
         *  Constant: '<S75>/Constant'
         *  Inport: '<Root>/ObjectInfo'
         *  Logic: '<S21>/Logical Operator'
         *  Logic: '<S21>/Logical Operator1'
         *  RelationalOperator: '<S74>/Compare'
         *  RelationalOperator: '<S75>/Compare'
         *  UnitDelay: '<S3>/Unit Delay'
         *  UnitDelay: '<S3>/Unit Delay1'
         */
        if (((MiddleRobotCtrl_mat_U.ObjectInfo[6] >=
              MiddleRobotCtrl_mat_P.Constant_Value_gd) &&
             ((MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE >=
               MiddleRobotCtrl_mat_P.Constant_Value_pv) != 0)) ||
            (MiddleRobotCtrl_mat_DWork.UnitDelay1_DSTATE != 0)) {
          rtb_Switch_d = MiddleRobotCtrl_mat_P.Constant_Value_hx;
        } else {
          rtb_Switch_d = MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE;
        }
      }
    }

    /* Switch: '<S83>/SwitchControl' incorporates:
     *  Constant: '<S21>/Constant3'
     *  Constant: '<S21>/Constant4'
     *  Constant: '<S83>/Constant'
     */
    if (MiddleRobotCtrl_mat_P.Constant_Value_a4 >
        MiddleRobotCtrl_mat_P.SwitchControl_Threshold) {
      rtb_SwitchControl = MiddleRobotCtrl_mat_P.Constant3_Value_h;
    } else {
      rtb_SwitchControl = MiddleRobotCtrl_mat_P.Constant4_Value_e;
    }

    /* Sum: '<S21>/Add' incorporates:
     *  Abs: '<S21>/Abs'
     *  Sum: '<S82>/Diff'
     *  UnitDelay: '<S82>/UD'
     */
    rtb_Switch_d += fabs(rtb_SwitchControl -
                         MiddleRobotCtrl_mat_DWork.UD_DSTATE_p);

    /* RelationalOperator: '<S25>/Compare' incorporates:
     *  Constant: '<S25>/Constant'
     */
    rtb_Compare_lu = (rtb_Switch_d == MiddleRobotCtrl_mat_P.Constant_Value_pq);

    /* RelationalOperator: '<S27>/Compare' incorporates:
     *  Constant: '<S27>/Constant'
     */
    rtb_Compare_fkd = (rtb_Switch_d == MiddleRobotCtrl_mat_P.Constant_Value_k);

    /* RelationalOperator: '<S34>/Compare' incorporates:
     *  Constant: '<S34>/Constant'
     */
    rtb_Compare_o3 = (rtb_Switch_d == MiddleRobotCtrl_mat_P.Constant_Value_kd);

    /* RelationalOperator: '<S41>/Compare' incorporates:
     *  Constant: '<S41>/Constant'
     */
    rtb_Compare_g = (rtb_Switch_d == MiddleRobotCtrl_mat_P.Constant_Value_pvf);

    /* RelationalOperator: '<S50>/Compare' incorporates:
     *  Constant: '<S50>/Constant'
     */
    rtb_Compare_h = (rtb_Switch_d == MiddleRobotCtrl_mat_P.Constant_Value_i);

    /* RelationalOperator: '<S58>/Compare' incorporates:
     *  Constant: '<S58>/Constant'
     */
    rtb_Compare_ik = (rtb_Switch_d == MiddleRobotCtrl_mat_P.Constant_Value_pa);

    /* RelationalOperator: '<S70>/Compare' incorporates:
     *  Constant: '<S70>/Constant'
     */
    rtb_Compare_hp = (rtb_Switch_d >= MiddleRobotCtrl_mat_P.Constant_Value_iz);

    /* RelationalOperator: '<S66>/Compare' incorporates:
     *  Constant: '<S66>/Constant'
     */
    rtb_Compare_e = (rtb_Switch_d == MiddleRobotCtrl_mat_P.Constant_Value_h);

    /* RelationalOperator: '<S72>/Compare' incorporates:
     *  Constant: '<S72>/Constant'
     */
    rtb_Compare_fr = (rtb_Switch_d >= MiddleRobotCtrl_mat_P.Constant_Value_ab);

    /* Logic: '<S3>/Logical Operator' incorporates:
     *  Constant: '<S26>/Constant'
     *  Constant: '<S28>/Constant'
     *  Constant: '<S32>/Constant'
     *  Constant: '<S40>/Constant'
     *  Constant: '<S49>/Constant'
     *  Constant: '<S56>/Constant'
     *  Constant: '<S65>/Constant'
     *  Constant: '<S71>/Constant'
     *  Constant: '<S73>/Constant'
     *  Inport: '<Root>/ArmInfo'
     *  Logic: '<S13>/Logical Operator'
     *  Logic: '<S14>/Logical Operator'
     *  Logic: '<S15>/Logical Operator'
     *  Logic: '<S16>/Logical Operator'
     *  Logic: '<S17>/Logical Operator'
     *  Logic: '<S18>/Logical Operator'
     *  Logic: '<S19>/Logical Operator1'
     *  Logic: '<S20>/Logical Operator1'
     *  Logic: '<S24>/Logical Operator'
     *  RelationalOperator: '<S26>/Compare'
     *  RelationalOperator: '<S28>/Compare'
     *  RelationalOperator: '<S32>/Compare'
     *  RelationalOperator: '<S40>/Compare'
     *  RelationalOperator: '<S49>/Compare'
     *  RelationalOperator: '<S56>/Compare'
     *  RelationalOperator: '<S65>/Compare'
     *  RelationalOperator: '<S71>/Compare'
     *  RelationalOperator: '<S73>/Compare'
     */
    rtb_LogicalOperator_ig = (((rtb_Compare_lu &&
      ((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
        MiddleRobotCtrl_mat_P.Constant_Value_j) != 0)) != 0) ||
      ((rtb_Compare_fkd && ((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
      MiddleRobotCtrl_mat_P.Constant_Value_m) != 0)) != 0) || ((rtb_Compare_o3 &&
                                ((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
      MiddleRobotCtrl_mat_P.Constant_Value_e) != 0)) != 0) || ((rtb_Compare_g &&
                                ((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
      MiddleRobotCtrl_mat_P.Constant_Value_mq) != 0)) != 0) || ((rtb_Compare_h &&
                                ((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
      MiddleRobotCtrl_mat_P.Constant_Value_po) != 0)) != 0) || ((rtb_Compare_ik &&
                                ((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
      MiddleRobotCtrl_mat_P.Constant_Value_a) != 0)) != 0) ||
      ((((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
          MiddleRobotCtrl_mat_P.Constant_Value_ja) != 0) && rtb_Compare_hp) != 0)
      || ((rtb_Compare_e && ((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
      MiddleRobotCtrl_mat_P.Constant_Value_c) != 0)) != 0) ||
      ((((MiddleRobotCtrl_mat_U.ArmInfo[0] ==
          MiddleRobotCtrl_mat_P.Constant_Value_n) != 0) && rtb_Compare_fr) != 0));

    /* Sum: '<S22>/Add' incorporates:
     *  Constant: '<S84>/Constant'
     *  RelationalOperator: '<S84>/Compare'
     *  Sum: '<S22>/Add1'
     *  UnitDelay: '<S22>/Unit Delay1'
     */
    rtb_Saturation_p = (real_T)((uint16_T)(rtb_LogicalOperator_ig -
      MiddleRobotCtrl_mat_DWork.UnitDelay1_DSTATE_i) ==
      MiddleRobotCtrl_mat_P.Constant_Value_k0) + rtb_Switch_d;

    /* Saturate: '<S22>/Saturation' */
    rtb_Saturation = rt_SATURATE(rtb_Saturation_p,
      MiddleRobotCtrl_mat_P.Saturation_LowerSat,
      MiddleRobotCtrl_mat_P.Saturation_UpperSat);

    /* Saturate: '<S3>/Saturation' */
    rtb_Saturation_p = rt_SATURATE(rtb_Saturation,
      MiddleRobotCtrl_mat_P.Saturation_LowerSat_m,
      MiddleRobotCtrl_mat_P.Saturation_UpperSat_n);

    /* Switch: '<S86>/Switch' incorporates:
     *  Constant: '<S1>/zero'
     *  Constant: '<S86>/L1'
     *  Constant: '<S86>/L3'
     *  Constant: '<S88>/Constant'
     *  RelationalOperator: '<S88>/Compare'
     */
    if (MiddleRobotCtrl_mat_P.zero_Value >=
        MiddleRobotCtrl_mat_P.Constant_Value_ej) {
      rtb_Switch_d = MiddleRobotCtrl_mat_P.L3_Value;
    } else {
      rtb_Switch_d = MiddleRobotCtrl_mat_P.L1_Value;
    }

    /* Sum: '<S86>/Add4' incorporates:
     *  Gain: '<S86>/Gain'
     *  Inport: '<Root>/ObjectInfo'
     */
    rtb_Switch_d += MiddleRobotCtrl_mat_P.Gain_Gain *
      MiddleRobotCtrl_mat_U.ObjectInfo[5];

    /* Sum: '<S91>/Add' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     *  Math: '<S91>/Math Function'
     *  Math: '<S91>/Math Function1'
     */
    rtb_Relay = MiddleRobotCtrl_mat_U.ObjectInfo[1] *
      MiddleRobotCtrl_mat_U.ObjectInfo[1] + MiddleRobotCtrl_mat_U.ObjectInfo[2] *
      MiddleRobotCtrl_mat_U.ObjectInfo[2];

    /* Math: '<S91>/Math Function2' */
    /* Operator : signedsqrt */
    rtb_MathFunction2 = rtb_Relay < 0.0 ? -sqrt(fabs(rtb_Relay)) : sqrt
      (rtb_Relay);

    /* Switch: '<S89>/Switch' incorporates:
     *  Saturate: '<S89>/Saturation'
     *  Saturate: '<S89>/Saturation1'
     *  Signum: '<S89>/Sign'
     */
    if (rt_SIGNd_snf(rtb_MathFunction2) >=
        MiddleRobotCtrl_mat_P.Switch_Threshold) {
      rtb_Relay = rt_SATURATE(rtb_MathFunction2,
        MiddleRobotCtrl_mat_P.Saturation_LowerSat_i,
        MiddleRobotCtrl_mat_P.Saturation_UpperSat_g);
    } else {
      rtb_Relay = rt_SATURATE(rtb_MathFunction2,
        MiddleRobotCtrl_mat_P.Saturation1_LowerSat_o,
        MiddleRobotCtrl_mat_P.Saturation1_UpperSat_a);
    }

    /* Sum: '<S86>/Add1' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     *  Product: '<S86>/Divide'
     *  Product: '<S86>/Divide2'
     */
    rtb_Add1 = MiddleRobotCtrl_mat_U.ObjectInfo[1] -
      MiddleRobotCtrl_mat_U.ObjectInfo[1] / rtb_Relay * rtb_Switch_d;

    /* Switch: '<S90>/Switch' incorporates:
     *  Saturate: '<S90>/Saturation'
     *  Saturate: '<S90>/Saturation1'
     *  Signum: '<S90>/Sign'
     */
    if (rt_SIGNd_snf(rtb_MathFunction2) >=
        MiddleRobotCtrl_mat_P.Switch_Threshold_i) {
      rtb_Relay = rt_SATURATE(rtb_MathFunction2,
        MiddleRobotCtrl_mat_P.Saturation_LowerSat_n,
        MiddleRobotCtrl_mat_P.Saturation_UpperSat_k);
    } else {
      rtb_Relay = rt_SATURATE(rtb_MathFunction2,
        MiddleRobotCtrl_mat_P.Saturation1_LowerSat_cv,
        MiddleRobotCtrl_mat_P.Saturation1_UpperSat_ex);
    }

    /* Sum: '<S86>/Add2' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     *  Product: '<S86>/Divide1'
     *  Product: '<S86>/Divide3'
     */
    rtb_Add2 = MiddleRobotCtrl_mat_U.ObjectInfo[2] -
      MiddleRobotCtrl_mat_U.ObjectInfo[2] / rtb_Relay * rtb_Switch_d;

    /* Relay: '<S86>/Relay' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     */
    if (MiddleRobotCtrl_mat_U.ObjectInfo[3] >= MiddleRobotCtrl_mat_P.Relay_OnVal)
    {
      MiddleRobotCtrl_mat_DWork.Relay_Mode = true;
    } else {
      if (MiddleRobotCtrl_mat_U.ObjectInfo[3] <=
          MiddleRobotCtrl_mat_P.Relay_OffVal) {
        MiddleRobotCtrl_mat_DWork.Relay_Mode = false;
      }
    }

    if (MiddleRobotCtrl_mat_DWork.Relay_Mode) {
      rtb_Relay = MiddleRobotCtrl_mat_P.Relay_YOn;
    } else {
      rtb_Relay = MiddleRobotCtrl_mat_P.Relay_YOff;
    }

    /* Switch: '<S86>/Switch1' incorporates:
     *  Constant: '<S86>/Hight offset'
     *  Constant: '<S86>/Z_offset'
     *  Inport: '<Root>/ObjectInfo'
     *  Sum: '<S86>/Add3'
     *  Sum: '<S86>/Add5'
     */
    if (rtb_Relay >= MiddleRobotCtrl_mat_P.Switch1_Threshold) {
      rtb_Switch1 = MiddleRobotCtrl_mat_P.Z_offset_Value_a +
        MiddleRobotCtrl_mat_U.ObjectInfo[3];
    } else {
      rtb_Switch1 = MiddleRobotCtrl_mat_U.ObjectInfo[4] +
        MiddleRobotCtrl_mat_P.Hightoffset_Value;
    }

    /* Sum: '<S95>/Add' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     *  Math: '<S95>/Math Function'
     *  Math: '<S95>/Math Function1'
     */
    rtb_Relay = MiddleRobotCtrl_mat_U.ObjectInfo[1] *
      MiddleRobotCtrl_mat_U.ObjectInfo[1] + MiddleRobotCtrl_mat_U.ObjectInfo[2] *
      MiddleRobotCtrl_mat_U.ObjectInfo[2];

    /* Math: '<S95>/Math Function2' */
    /* Operator : signedsqrt */
    rtb_MathFunction2_i = rtb_Relay < 0.0 ? -sqrt(fabs(rtb_Relay)) : sqrt
      (rtb_Relay);

    /* RelationalOperator: '<S92>/Compare' incorporates:
     *  Constant: '<S1>/zero'
     *  Constant: '<S92>/Constant'
     */
    rtb_Compare_ft = (MiddleRobotCtrl_mat_P.zero_Value >=
                      MiddleRobotCtrl_mat_P.Constant_Value_ei);

    /* Switch: '<S87>/Switch1' incorporates:
     *  Gain: '<S87>/Gain'
     *  Gain: '<S87>/Gain1'
     *  Inport: '<Root>/ObjectInfo'
     *  Lookup: '<S87>/Lookup Table'
     */
    if (rtb_Compare_ft) {
      /* Lookup: '<S87>/Lookup Table'
       * About '<S87>/Lookup Table':
       * Input0  Data Type:  Floating Point real_T
       * Output0 Data Type:  Floating Point real_T
       * Lookup Method: Linear_Endpoint
       *
       * XData parameter uses the same data type and scaling as Input0
       * YData parameter uses the same data type and scaling as Output0
       */
      LookUp_real_T_real_T( &(rtb_LookupTable),
                           MiddleRobotCtrl_mat_P.LookupTable_YData_h,
                           rtb_MathFunction2_i,
                           MiddleRobotCtrl_mat_P.LookupTable_XData_f, 6U);
      rtb_Relay = MiddleRobotCtrl_mat_P.Gain1_Gain_h * rtb_LookupTable;
    } else {
      rtb_Relay = MiddleRobotCtrl_mat_P.Gain_Gain_g *
        MiddleRobotCtrl_mat_U.ObjectInfo[5];
    }

    /* Switch: '<S93>/Switch' incorporates:
     *  Saturate: '<S93>/Saturation'
     *  Saturate: '<S93>/Saturation1'
     *  Signum: '<S93>/Sign'
     */
    if (rt_SIGNd_snf(rtb_MathFunction2_i) >=
        MiddleRobotCtrl_mat_P.Switch_Threshold_b) {
      rtb_Switch_d = rt_SATURATE(rtb_MathFunction2_i,
        MiddleRobotCtrl_mat_P.Saturation_LowerSat_g,
        MiddleRobotCtrl_mat_P.Saturation_UpperSat_m);
    } else {
      rtb_Switch_d = rt_SATURATE(rtb_MathFunction2_i,
        MiddleRobotCtrl_mat_P.Saturation1_LowerSat_og,
        MiddleRobotCtrl_mat_P.Saturation1_UpperSat_oa);
    }

    /* Sum: '<S87>/Add3' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     *  Product: '<S87>/Divide4'
     *  Product: '<S87>/Divide6'
     */
    rtb_Add3 = MiddleRobotCtrl_mat_U.ObjectInfo[1] -
      MiddleRobotCtrl_mat_U.ObjectInfo[1] / rtb_Switch_d * rtb_Relay;

    /* Switch: '<S94>/Switch' incorporates:
     *  Saturate: '<S94>/Saturation'
     *  Saturate: '<S94>/Saturation1'
     *  Signum: '<S94>/Sign'
     */
    if (rt_SIGNd_snf(rtb_MathFunction2_i) >=
        MiddleRobotCtrl_mat_P.Switch_Threshold_d) {
      rtb_Switch_d = rt_SATURATE(rtb_MathFunction2_i,
        MiddleRobotCtrl_mat_P.Saturation_LowerSat_e,
        MiddleRobotCtrl_mat_P.Saturation_UpperSat_i);
    } else {
      rtb_Switch_d = rt_SATURATE(rtb_MathFunction2_i,
        MiddleRobotCtrl_mat_P.Saturation1_LowerSat_i,
        MiddleRobotCtrl_mat_P.Saturation1_UpperSat_p);
    }

    /* Sum: '<S87>/Add4' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     *  Product: '<S87>/Divide5'
     *  Product: '<S87>/Divide7'
     */
    rtb_Add4 = MiddleRobotCtrl_mat_U.ObjectInfo[2] -
      MiddleRobotCtrl_mat_U.ObjectInfo[2] / rtb_Switch_d * rtb_Relay;

    /* Relay: '<S87>/Relay' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     */
    if (MiddleRobotCtrl_mat_U.ObjectInfo[3] >=
        MiddleRobotCtrl_mat_P.Relay_OnVal_a) {
      MiddleRobotCtrl_mat_DWork.Relay_Mode_n = true;
    } else {
      if (MiddleRobotCtrl_mat_U.ObjectInfo[3] <=
          MiddleRobotCtrl_mat_P.Relay_OffVal_f) {
        MiddleRobotCtrl_mat_DWork.Relay_Mode_n = false;
      }
    }

    if (MiddleRobotCtrl_mat_DWork.Relay_Mode_n) {
      rtb_Relay = MiddleRobotCtrl_mat_P.Relay_YOn_c;
    } else {
      rtb_Relay = MiddleRobotCtrl_mat_P.Relay_YOff_k;
    }

    /* Gain: '<S87>/Gain3' */
    rtb_Relay *= MiddleRobotCtrl_mat_P.Gain3_Gain;

    /* Gain: '<S87>/Gain2' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     */
    rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Gain2_Gain *
      MiddleRobotCtrl_mat_U.ObjectInfo[4];

    /* Switch: '<S87>/Switch3' incorporates:
     *  Constant: '<S87>/Z_offset'
     *  Inport: '<Root>/ObjectInfo'
     *  Sum: '<S87>/Add5'
     */
    if (rtb_Relay >= MiddleRobotCtrl_mat_P.Switch3_Threshold) {
      rtb_Relay = MiddleRobotCtrl_mat_P.Z_offset_Value_d +
        MiddleRobotCtrl_mat_U.ObjectInfo[3];
    } else {
      /* Switch: '<S87>/Switch2' incorporates:
       *  Lookup: '<S87>/Lookup Table1'
       *  Lookup: '<S87>/Lookup Table2'
       *  Product: '<S87>/Divide1'
       *  Sum: '<S87>/Add2'
       */
      if (rtb_Compare_ft) {
        rtb_Relay = rt_Lookup((const real_T *)
                              (&MiddleRobotCtrl_mat_P.LookupTable2_XData[0]), 8,
                              rtb_MathFunction2_i, (const real_T *)
                              (&MiddleRobotCtrl_mat_P.LookupTable2_YData[0])) +
          rtb_MathFunction2;
      } else {
        /* Lookup: '<S87>/Lookup Table1'
         * About '<S87>/Lookup Table1':
         * Input0  Data Type:  Floating Point real_T
         * Output0 Data Type:  Floating Point real_T
         * Lookup Method: Linear_Endpoint
         *
         * XData parameter uses the same data type and scaling as Input0
         * YData parameter uses the same data type and scaling as Output0
         */
        LookUp_real_T_real_T( &(rtb_LookupTable1),
                             MiddleRobotCtrl_mat_P.LookupTable1_YData_d,
                             rtb_MathFunction2_i,
                             MiddleRobotCtrl_mat_P.LookupTable1_XData_m, 6U);
        rtb_Relay = rtb_MathFunction2 * rtb_LookupTable1;
      }
    }

    /* Saturate: '<S87>/Saturation' */
    rtb_MathFunction2 = rt_SATURATE(rtb_Relay,
      MiddleRobotCtrl_mat_P.Saturation_LowerSat_b,
      MiddleRobotCtrl_mat_P.Saturation_UpperSat_f);

    /* Relay: '<S44>/Relay' incorporates:
     *  Inport: '<Root>/ObjectInfo'
     */
    if (MiddleRobotCtrl_mat_U.ObjectInfo[3] >=
        MiddleRobotCtrl_mat_P.Relay_OnVal_a4) {
      MiddleRobotCtrl_mat_DWork.Relay_Mode_m = true;
    } else {
      if (MiddleRobotCtrl_mat_U.ObjectInfo[3] <=
          MiddleRobotCtrl_mat_P.Relay_OffVal_h) {
        MiddleRobotCtrl_mat_DWork.Relay_Mode_m = false;
      }
    }

    if (MiddleRobotCtrl_mat_DWork.Relay_Mode_m) {
      rtb_Relay = MiddleRobotCtrl_mat_P.Relay_YOn_b;
    } else {
      rtb_Relay = MiddleRobotCtrl_mat_P.Relay_YOff_j;
    }

    /* MultiPortSwitch: '<S3>/Multiport Switch' */
    switch ((int32_T)rtb_Saturation_p) {
     case 1:
      /* Switch: '<S24>/Switch1' incorporates:
       *  Constant: '<S24>/Constant3'
       *  Saturate: '<S24>/Saturation1'
       */
      if (rtb_Compare_lu) {
        rtb_pos_k_idx = rt_SATURATE(rtb_Add1,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_j[0],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_m[0]);
        rtb_pos_k_idx_0 = rt_SATURATE(rtb_Add2,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_j[1],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_m[1]);
        rtb_MathFunction2 = rt_SATURATE(rtb_Switch1,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_j[2],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_m[2]);
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_hm[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_hm[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_hm[2];
      }
      break;

     case 2:
      /* Switch: '<S13>/Switch1' incorporates:
       *  Constant: '<S13>/Constant3'
       *  Saturate: '<S13>/Saturation1'
       */
      if (rtb_Compare_fkd) {
        rtb_pos_k_idx = rt_SATURATE(rtb_Add1,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_g[0],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_o[0]);
        rtb_pos_k_idx_0 = rt_SATURATE(rtb_Add2,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_g[1],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_o[1]);
        rtb_MathFunction2 = rt_SATURATE(rtb_Switch1,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_g[2],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_o[2]);
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_c[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_c[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_c[2];
      }
      break;

     case 3:
      /* Switch: '<S14>/Switch1' incorporates:
       *  Constant: '<S14>/Constant3'
       *  Saturate: '<S14>/Saturation1'
       */
      if (rtb_Compare_o3) {
        rtb_pos_k_idx = rt_SATURATE(rtb_Add3,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_a[0],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_gi[0]);
        rtb_pos_k_idx_0 = rt_SATURATE(rtb_Add4,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_a[1],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_gi[1]);
        rtb_MathFunction2 = rt_SATURATE(rtb_MathFunction2,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_a[2],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_gi[2]);
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_p[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_p[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_p[2];
      }
      break;

     case 4:
      /* Switch: '<S15>/Switch1' incorporates:
       *  Constant: '<S15>/Constant3'
       *  Sum: '<S44>/Add'
       */
      if (rtb_Compare_g) {
        /* Saturate: '<S15>/Saturation1' */
        rtb_Switch1 = rt_SATURATE(rtb_Add3,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_n[0],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_g[0]);
        rtb_Add3 = rt_SATURATE(rtb_Add4,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_n[1],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_g[1]);
        rtb_Add1 = rt_SATURATE(rtb_MathFunction2,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_n[2],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_g[2]);

        /* Sum: '<S48>/Sum of Elements' incorporates:
         *  Inport: '<Root>/ObjectInfo'
         *  Math: '<S48>/Math Function'
         */
        rtb_MathFunction1_k = MiddleRobotCtrl_mat_U.ObjectInfo[1] *
          MiddleRobotCtrl_mat_U.ObjectInfo[1] +
          MiddleRobotCtrl_mat_U.ObjectInfo[2] *
          MiddleRobotCtrl_mat_U.ObjectInfo[2];

        /* Math: '<S48>/Math Function1' */
        /* Operator : signedsqrt */
        rtb_MathFunction1_k = rtb_MathFunction1_k < 0.0 ? -sqrt(fabs
          (rtb_MathFunction1_k)) : sqrt(rtb_MathFunction1_k);

        /* Lookup: '<S44>/Lookup Table1'
         * About '<S44>/Lookup Table1':
         * Input0  Data Type:  Floating Point real_T
         * Output0 Data Type:  Floating Point real_T
         * Lookup Method: Linear_Endpoint
         *
         * XData parameter uses the same data type and scaling as Input0
         * YData parameter uses the same data type and scaling as Output0
         */
        LookUp_real_T_real_T( &(rtb_LookupTable1_c),
                             MiddleRobotCtrl_mat_P.LookupTable1_YData,
                             rtb_MathFunction1_k,
                             MiddleRobotCtrl_mat_P.LookupTable1_XData, 4U);

        /* Lookup: '<S44>/Lookup Table'
         * About '<S44>/Lookup Table':
         * Input0  Data Type:  Floating Point real_T
         * Output0 Data Type:  Floating Point real_T
         * Lookup Method: Linear_Endpoint
         *
         * XData parameter uses the same data type and scaling as Input0
         * YData parameter uses the same data type and scaling as Output0
         */
        LookUp_real_T_real_T( &(rtb_LookupTable_l),
                             MiddleRobotCtrl_mat_P.LookupTable_YData,
                             rtb_MathFunction1_k,
                             MiddleRobotCtrl_mat_P.LookupTable_XData, 4U);

        /* Switch: '<S44>/Switch1' incorporates:
         *  Constant: '<S44>/Constant7'
         *  Constant: '<S44>/Z_offset'
         *  Sum: '<S44>/Add'
         */
        if (rtb_Relay >= MiddleRobotCtrl_mat_P.Switch1_Threshold_l) {
          rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Z_offset_Value;
        } else {
          rtb_MathFunction2 = rtb_LookupTable1_c + rtb_Add1;
        }

        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant7_Value + rtb_Switch1;
        rtb_pos_k_idx_0 = rtb_LookupTable_l + rtb_Add3;
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_n[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_n[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_n[2];
      }
      break;

     case 5:
      /* Switch: '<S16>/Switch1' incorporates:
       *  Constant: '<S16>/Constant3'
       *  Constant: '<S52>/Clear_pos'
       *  Saturate: '<S16>/Saturation1'
       */
      if (rtb_Compare_h) {
        rtb_pos_k_idx = rt_SATURATE(MiddleRobotCtrl_mat_P.Clear_pos_Value[0],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_e[0],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_b[0]);
        rtb_pos_k_idx_0 = rt_SATURATE(MiddleRobotCtrl_mat_P.Clear_pos_Value[1],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_e[1],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_b[1]);
        rtb_MathFunction2 = rt_SATURATE(MiddleRobotCtrl_mat_P.Clear_pos_Value[2],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_e[2],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_b[2]);
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_hb[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_hb[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_hb[2];
      }
      break;

     case 6:
      /* Switch: '<S17>/Switch1' incorporates:
       *  Constant: '<S17>/Constant3'
       */
      if (rtb_Compare_ik) {
        /* Saturate: '<S17>/Saturation1' incorporates:
         *  Constant: '<S60>/Cup'
         *  Constant: '<S60>/Height_offset'
         *  Inport: '<Root>/ObjectInfo'
         *  Sum: '<S60>/Add'
         */
        rtb_Add1 = MiddleRobotCtrl_mat_P.Height_offset_Value +
          MiddleRobotCtrl_mat_U.ObjectInfo[4];
        rtb_pos_k_idx = rt_SATURATE(MiddleRobotCtrl_mat_P.Cup_Value_n[0],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_f[0],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_eq[0]);
        rtb_pos_k_idx_0 = rt_SATURATE(MiddleRobotCtrl_mat_P.Cup_Value_n[1],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_f[1],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_eq[1]);
        rtb_MathFunction2 = rt_SATURATE(rtb_Add1,
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_f[2],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_eq[2]);
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_i[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_i[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_i[2];
      }
      break;

     case 7:
      /* Switch: '<S18>/Switch1' incorporates:
       *  Constant: '<S18>/Constant3'
       *  Constant: '<S68>/Cup'
       *  Saturate: '<S18>/Saturation1'
       */
      if (rtb_Compare_e) {
        rtb_pos_k_idx = rt_SATURATE(MiddleRobotCtrl_mat_P.Cup_Value[0],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_k[0],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_fz[0]);
        rtb_pos_k_idx_0 = rt_SATURATE(MiddleRobotCtrl_mat_P.Cup_Value[1],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_k[1],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_fz[1]);
        rtb_MathFunction2 = rt_SATURATE(MiddleRobotCtrl_mat_P.Cup_Value[2],
          MiddleRobotCtrl_mat_P.Saturation1_LowerSat_k[2],
          MiddleRobotCtrl_mat_P.Saturation1_UpperSat_fz[2]);
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_e2[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_e2[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_e2[2];
      }
      break;

     case 8:
      /* Switch: '<S19>/Switch1' incorporates:
       *  Constant: '<S19>/Constant3'
       *  Constant: '<S19>/stand_pos1'
       */
      if (rtb_Compare_hp) {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.stand_pos1_Value_i[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.stand_pos1_Value_i[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.stand_pos1_Value_i[2];
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_m[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_m[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_m[2];
      }
      break;

     default:
      /* Switch: '<S20>/Switch1' incorporates:
       *  Constant: '<S20>/Constant3'
       *  Constant: '<S20>/stand_pos1'
       */
      if (rtb_Compare_fr) {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.stand_pos1_Value[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.stand_pos1_Value[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.stand_pos1_Value[2];
      } else {
        rtb_pos_k_idx = MiddleRobotCtrl_mat_P.Constant3_Value_e[0];
        rtb_pos_k_idx_0 = MiddleRobotCtrl_mat_P.Constant3_Value_e[1];
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant3_Value_e[2];
      }
      break;
    }

    /* Saturate: '<S3>/Saturation1' */
    rtb_Add4 = rt_SATURATE(rtb_pos_k_idx,
      MiddleRobotCtrl_mat_P.Saturation1_LowerSat[0],
      MiddleRobotCtrl_mat_P.Saturation1_UpperSat[0]);

    /* Abs: '<S7>/Abs' */
    rtb_Switch1 = fabs(rtb_Add4);
    rtb_pos_k_idx = rtb_Add4;

    /* Saturate: '<S3>/Saturation1' */
    rtb_Add4 = rt_SATURATE(rtb_pos_k_idx_0,
      MiddleRobotCtrl_mat_P.Saturation1_LowerSat[1],
      MiddleRobotCtrl_mat_P.Saturation1_UpperSat[1]);

    /* Abs: '<S7>/Abs' */
    rtb_Add3 = fabs(rtb_Add4);
    rtb_pos_k_idx_0 = rtb_Add4;

    /* Saturate: '<S3>/Saturation1' */
    rtb_Add4 = rt_SATURATE(rtb_MathFunction2,
      MiddleRobotCtrl_mat_P.Saturation1_LowerSat[2],
      MiddleRobotCtrl_mat_P.Saturation1_UpperSat[2]);

    /* Sum: '<S7>/Sum of Elements' incorporates:
     *  Abs: '<S7>/Abs'
     */
    rtb_Add1 = (rtb_Switch1 + rtb_Add3) + fabs(rtb_Add4);

    /* Abs: '<S7>/Abs1' incorporates:
     *  Sum: '<S10>/Diff'
     *  UnitDelay: '<S10>/UD'
     */
    rtb_Add2 = fabs(rtb_Add1 - MiddleRobotCtrl_mat_DWork.UD_DSTATE_e);

    /* Switch: '<S2>/Switch1' incorporates:
     *  Constant: '<S2>/Constant2'
     */
    if (rtb_Compare >= MiddleRobotCtrl_mat_P.Switch1_Threshold_j) {
      rtb_Relay = MiddleRobotCtrl_mat_P.Constant2_Value;
    } else {
      /* Switch: '<S2>/Switch' incorporates:
       *  Constant: '<S2>/Constant'
       *  Constant: '<S2>/Constant1'
       *  Constant: '<S8>/Constant'
       *  Constant: '<S9>/Constant'
       *  Logic: '<S7>/Logical Operator'
       *  RelationalOperator: '<S8>/Compare'
       *  RelationalOperator: '<S9>/Compare'
       *  Sum: '<S11>/Diff'
       *  UnitDelay: '<S11>/UD'
       */
      if ((rtb_Add2 - MiddleRobotCtrl_mat_DWork.UD_DSTATE_j <
           MiddleRobotCtrl_mat_P.Constant_Value_ew) && (rtb_Add2 <
           MiddleRobotCtrl_mat_P.Constant_Value_iq)) {
        rtb_Relay = MiddleRobotCtrl_mat_P.Constant_Value_ejc;
      } else {
        rtb_Relay = MiddleRobotCtrl_mat_P.Constant1_Value_e;
      }
    }

    /* Outport: '<Root>/Mode_ID' incorporates:
     *  Gain: '<S2>/Gain'
     */
    MiddleRobotCtrl_mat_Y.Mode_ID = MiddleRobotCtrl_mat_P.Gain_Gain_e *
      rtb_Relay;

    /* Logic: '<S14>/Logical Operator2' */
    rtb_Compare_lu = !rtb_Compare_o3;

    /* Logic: '<S14>/Logical Operator1' incorporates:
     *  Constant: '<S33>/Constant'
     *  Inport: '<Root>/ArmInfo'
     *  RelationalOperator: '<S33>/Compare'
     */
    rtb_LogicalOperator1 = (rtb_Compare_o3 && ((MiddleRobotCtrl_mat_U.ArmInfo[0]
      == MiddleRobotCtrl_mat_P.Constant_Value_b) != 0));

    /* Switch: '<S14>/Switch4' incorporates:
     *  Logic: '<S14>/Logical Operator3'
     *  UnitDelay: '<S14>/Unit Delay'
     */
    if ((rtb_Compare_lu || (rtb_LogicalOperator1 != 0)) >=
        MiddleRobotCtrl_mat_P.Switch4_Threshold) {
      /* Switch: '<S14>/Switch5' incorporates:
       *  Constant: '<S14>/Constant2'
       */
      if (rtb_Compare_lu) {
        rtb_MathFunction2 = MiddleRobotCtrl_mat_P.Constant2_Value_m;
      } else {
        rtb_MathFunction2 = (real_T)rtb_LogicalOperator1;
      }
    } else {
      rtb_MathFunction2 = MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE_g;
    }

    /* Logic: '<S17>/Logical Operator2' */
    rtb_Compare_lu = !rtb_Compare_ik;

    /* Logic: '<S17>/Logical Operator1' incorporates:
     *  Constant: '<S57>/Constant'
     *  Inport: '<Root>/ArmInfo'
     *  RelationalOperator: '<S57>/Compare'
     */
    rtb_LogicalOperator1 = (rtb_Compare_ik && ((MiddleRobotCtrl_mat_U.ArmInfo[0]
      == MiddleRobotCtrl_mat_P.Constant_Value_d) != 0));

    /* Switch: '<S17>/Switch4' incorporates:
     *  Logic: '<S17>/Logical Operator3'
     *  UnitDelay: '<S17>/Unit Delay'
     */
    if ((rtb_Compare_lu || (rtb_LogicalOperator1 != 0)) >=
        MiddleRobotCtrl_mat_P.Switch4_Threshold_p) {
      /* Switch: '<S17>/Switch5' incorporates:
       *  Constant: '<S17>/Constant2'
       */
      if (rtb_Compare_lu) {
        rtb_Relay = MiddleRobotCtrl_mat_P.Constant2_Value_k;
      } else {
        rtb_Relay = (real_T)rtb_LogicalOperator1;
      }
    } else {
      rtb_Relay = MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE_j;
    }

    /* MultiPortSwitch: '<S3>/Multiport Switch' incorporates:
     *  Constant: '<S13>/Constant2'
     *  Constant: '<S18>/Constant6'
     *  Constant: '<S19>/Constant2'
     *  Constant: '<S20>/Constant2'
     *  Constant: '<S24>/Constant2'
     *  Gain: '<S15>/Gain'
     *  Gain: '<S16>/Gain'
     *  Saturate: '<S43>/Saturation1'
     *  Saturate: '<S53>/Saturation1'
     */
    switch ((int32_T)rtb_Saturation_p) {
     case 1:
      MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Constant2_Value_l;
      break;

     case 2:
      MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Constant2_Value_j;
      break;

     case 3:
      /* Switch: '<S14>/Switch3' incorporates:
       *  Constant: '<S14>/hand_before'
       *  Gain: '<S14>/Gain'
       *  Saturate: '<S36>/Saturation1'
       */
      if (rtb_MathFunction2 >= MiddleRobotCtrl_mat_P.Switch3_Threshold_nn) {
        /* Sum: '<S39>/Add' incorporates:
         *  Inport: '<Root>/ObjectInfo'
         *  Math: '<S39>/Math Function'
         *  Math: '<S39>/Math Function1'
         */
        rtb_MathFunction2_p = MiddleRobotCtrl_mat_U.ObjectInfo[1] *
          MiddleRobotCtrl_mat_U.ObjectInfo[1] +
          MiddleRobotCtrl_mat_U.ObjectInfo[2] *
          MiddleRobotCtrl_mat_U.ObjectInfo[2];

        /* Math: '<S39>/Math Function2' */
        /* Operator : signedsqrt */
        rtb_MathFunction2_p = rtb_MathFunction2_p < 0.0 ? -sqrt(fabs
          (rtb_MathFunction2_p)) : sqrt(rtb_MathFunction2_p);

        /* Lookup2D: '<S36>/Lookup Table (2-D)'
         * About '<S36>/Lookup Table (2-D)':
         * Input0  Data Type:  Floating Point real_T
         * Input1  Data Type:  Floating Point real_T
         * Output0 Data Type:  Floating Point real_T
         * Lookup Method: Linear_Endpoint
         *
         * Row Data    parameter uses the same data type and scaling as Input0
         * Column Data parameter uses the same data type and scaling as Input1
         * Table Data  parameter uses the same data type and scaling as Output0
         */
        Look2D_real_T_real_T_real_T( &(rtb_LookupTable2D),
          MiddleRobotCtrl_mat_P.LookupTable2D_Table_f,
          MiddleRobotCtrl_mat_U.ObjectInfo[5],
          MiddleRobotCtrl_mat_P.LookupTable2D_RowIdx_l, 5U, rtb_MathFunction2_p,
          MiddleRobotCtrl_mat_P.LookupTable2D_ColIdx_i, 3U);
        MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Gain_Gain_eq *
          rt_SATURATE(rtb_LookupTable2D,
                      MiddleRobotCtrl_mat_P.Saturation1_LowerSat_d,
                      MiddleRobotCtrl_mat_P.Saturation1_UpperSat_f);
      } else {
        MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.hand_before_Value;
      }
      break;

     case 4:
      /* Sum: '<S47>/Add' incorporates:
       *  Inport: '<Root>/ObjectInfo'
       *  Math: '<S47>/Math Function'
       *  Math: '<S47>/Math Function1'
       */
      rtb_MathFunction2_g = MiddleRobotCtrl_mat_U.ObjectInfo[1] *
        MiddleRobotCtrl_mat_U.ObjectInfo[1] + MiddleRobotCtrl_mat_U.ObjectInfo[2]
        * MiddleRobotCtrl_mat_U.ObjectInfo[2];

      /* Math: '<S47>/Math Function2' */
      /* Operator : signedsqrt */
      rtb_MathFunction2_g = rtb_MathFunction2_g < 0.0 ? -sqrt(fabs
        (rtb_MathFunction2_g)) : sqrt(rtb_MathFunction2_g);

      /* Lookup2D: '<S43>/Lookup Table (2-D)'
       * About '<S43>/Lookup Table (2-D)':
       * Input0  Data Type:  Floating Point real_T
       * Input1  Data Type:  Floating Point real_T
       * Output0 Data Type:  Floating Point real_T
       * Lookup Method: Linear_Endpoint
       *
       * Row Data    parameter uses the same data type and scaling as Input0
       * Column Data parameter uses the same data type and scaling as Input1
       * Table Data  parameter uses the same data type and scaling as Output0
       */
      Look2D_real_T_real_T_real_T( &(rtb_LookupTable2D_d),
        MiddleRobotCtrl_mat_P.LookupTable2D_Table_d,
        MiddleRobotCtrl_mat_U.ObjectInfo[5],
        MiddleRobotCtrl_mat_P.LookupTable2D_RowIdx_h, 5U, rtb_MathFunction2_g,
        MiddleRobotCtrl_mat_P.LookupTable2D_ColIdx_g, 3U);
      MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Gain_Gain_og *
        rt_SATURATE(rtb_LookupTable2D_d,
                    MiddleRobotCtrl_mat_P.Saturation1_LowerSat_b,
                    MiddleRobotCtrl_mat_P.Saturation1_UpperSat_e);
      break;

     case 5:
      /* Sum: '<S55>/Add' incorporates:
       *  Inport: '<Root>/ObjectInfo'
       *  Math: '<S55>/Math Function'
       *  Math: '<S55>/Math Function1'
       */
      rtb_MathFunction2_gx = MiddleRobotCtrl_mat_U.ObjectInfo[1] *
        MiddleRobotCtrl_mat_U.ObjectInfo[1] + MiddleRobotCtrl_mat_U.ObjectInfo[2]
        * MiddleRobotCtrl_mat_U.ObjectInfo[2];

      /* Math: '<S55>/Math Function2' */
      /* Operator : signedsqrt */
      rtb_MathFunction2_gx = rtb_MathFunction2_gx < 0.0 ? -sqrt(fabs
        (rtb_MathFunction2_gx)) : sqrt(rtb_MathFunction2_gx);

      /* Lookup2D: '<S53>/Lookup Table (2-D)'
       * About '<S53>/Lookup Table (2-D)':
       * Input0  Data Type:  Floating Point real_T
       * Input1  Data Type:  Floating Point real_T
       * Output0 Data Type:  Floating Point real_T
       * Lookup Method: Linear_Endpoint
       *
       * Row Data    parameter uses the same data type and scaling as Input0
       * Column Data parameter uses the same data type and scaling as Input1
       * Table Data  parameter uses the same data type and scaling as Output0
       */
      Look2D_real_T_real_T_real_T( &(rtb_LookupTable2D_b),
        MiddleRobotCtrl_mat_P.LookupTable2D_Table_c,
        MiddleRobotCtrl_mat_U.ObjectInfo[5],
        MiddleRobotCtrl_mat_P.LookupTable2D_RowIdx_c, 5U, rtb_MathFunction2_gx,
        MiddleRobotCtrl_mat_P.LookupTable2D_ColIdx_h, 3U);
      MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Gain_Gain_o *
        rt_SATURATE(rtb_LookupTable2D_b,
                    MiddleRobotCtrl_mat_P.Saturation1_LowerSat_c,
                    MiddleRobotCtrl_mat_P.Saturation1_UpperSat_k);
      break;

     case 6:
      /* Switch: '<S17>/Switch3' incorporates:
       *  Constant: '<S61>/Constant'
       *  Gain: '<S17>/Gain'
       *  Gain: '<S17>/Gain1'
       *  Saturate: '<S62>/Saturation1'
       */
      if (rtb_Relay >= MiddleRobotCtrl_mat_P.Switch3_Threshold_n) {
        MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Gain_Gain_n *
          MiddleRobotCtrl_mat_P.Constant_Value_jl;
      } else {
        /* Sum: '<S64>/Add' incorporates:
         *  Inport: '<Root>/ObjectInfo'
         *  Math: '<S64>/Math Function'
         *  Math: '<S64>/Math Function1'
         */
        rtb_MathFunction2_f = MiddleRobotCtrl_mat_U.ObjectInfo[1] *
          MiddleRobotCtrl_mat_U.ObjectInfo[1] +
          MiddleRobotCtrl_mat_U.ObjectInfo[2] *
          MiddleRobotCtrl_mat_U.ObjectInfo[2];

        /* Math: '<S64>/Math Function2' */
        /* Operator : signedsqrt */
        rtb_MathFunction2_f = rtb_MathFunction2_f < 0.0 ? -sqrt(fabs
          (rtb_MathFunction2_f)) : sqrt(rtb_MathFunction2_f);

        /* Lookup2D: '<S62>/Lookup Table (2-D)'
         * About '<S62>/Lookup Table (2-D)':
         * Input0  Data Type:  Floating Point real_T
         * Input1  Data Type:  Floating Point real_T
         * Output0 Data Type:  Floating Point real_T
         * Lookup Method: Linear_Endpoint
         *
         * Row Data    parameter uses the same data type and scaling as Input0
         * Column Data parameter uses the same data type and scaling as Input1
         * Table Data  parameter uses the same data type and scaling as Output0
         */
        Look2D_real_T_real_T_real_T( &(rtb_LookupTable2D_h),
          MiddleRobotCtrl_mat_P.LookupTable2D_Table,
          MiddleRobotCtrl_mat_U.ObjectInfo[5],
          MiddleRobotCtrl_mat_P.LookupTable2D_RowIdx, 5U, rtb_MathFunction2_f,
          MiddleRobotCtrl_mat_P.LookupTable2D_ColIdx, 3U);
        MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Gain1_Gain *
          rt_SATURATE(rtb_LookupTable2D_h,
                      MiddleRobotCtrl_mat_P.Saturation1_LowerSat_l,
                      MiddleRobotCtrl_mat_P.Saturation1_UpperSat_c);
      }
      break;

     case 7:
      MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Constant6_Value;
      break;

     case 8:
      MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Constant2_Value_ou;
      break;

     default:
      MiddleRobotCtrl_mat_Y.Gripper = MiddleRobotCtrl_mat_P.Constant2_Value_f;
      break;
    }

    /* Outport: '<Root>/TransMatrix' incorporates:
     *  Constant: '<S2>/Constant3'
     *  Constant: '<S2>/Constant4'
     *  Constant: '<S2>/Constant5'
     */
    MiddleRobotCtrl_mat_Y.TransMatrix[0] = MiddleRobotCtrl_mat_P.Constant3_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[1] = MiddleRobotCtrl_mat_P.Constant3_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[2] = MiddleRobotCtrl_mat_P.Constant3_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[3] = rtb_pos_k_idx;
    MiddleRobotCtrl_mat_Y.TransMatrix[4] = MiddleRobotCtrl_mat_P.Constant4_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[5] = MiddleRobotCtrl_mat_P.Constant4_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[6] = MiddleRobotCtrl_mat_P.Constant4_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[7] = rtb_pos_k_idx_0;
    MiddleRobotCtrl_mat_Y.TransMatrix[8] = MiddleRobotCtrl_mat_P.Constant5_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[9] = MiddleRobotCtrl_mat_P.Constant5_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[10] =
      MiddleRobotCtrl_mat_P.Constant5_Value;
    MiddleRobotCtrl_mat_Y.TransMatrix[11] = rtb_Add4;

    /* Outport: '<Root>/RAC_ID' */
    MiddleRobotCtrl_mat_Y.RAC_ID = rtb_Saturation;

    /* Update for S-Function (sfix_udelay): '<S2>/Integer Delay' */
    MiddleRobotCtrl_mat_DWork.IntegerDelay_X[0] =
      MiddleRobotCtrl_mat_DWork.IntegerDelay_X[1];
    MiddleRobotCtrl_mat_DWork.IntegerDelay_X[1] =
      MiddleRobotCtrl_mat_DWork.IntegerDelay_X[2];
    MiddleRobotCtrl_mat_DWork.IntegerDelay_X[2] =
      MiddleRobotCtrl_mat_DWork.IntegerDelay_X[3];
    MiddleRobotCtrl_mat_DWork.IntegerDelay_X[3] =
      MiddleRobotCtrl_mat_DWork.IntegerDelay_X[4];
    MiddleRobotCtrl_mat_DWork.IntegerDelay_X[4] = MiddleRobotCtrl_mat_Y.Gripper;

    /* Update for UnitDelay: '<S6>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE = rtb_IntegerDelay;

    /* Update for UnitDelay: '<S3>/Unit Delay' */
    MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE = rtb_Saturation;

    /* Update for UnitDelay: '<S3>/Unit Delay1' incorporates:
     *  Constant: '<S14>/Constant1'
     *  Constant: '<S16>/Constant1'
     *  Logic: '<S3>/Logical Operator1'
     */
    MiddleRobotCtrl_mat_DWork.UnitDelay1_DSTATE =
      ((MiddleRobotCtrl_mat_P.Constant1_Value != 0.0) ||
       (MiddleRobotCtrl_mat_P.Constant1_Value_i != 0.0));

    /* Update for UnitDelay: '<S82>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE_p = rtb_SwitchControl;

    /* Update for UnitDelay: '<S22>/Unit Delay1' */
    MiddleRobotCtrl_mat_DWork.UnitDelay1_DSTATE_i = rtb_LogicalOperator_ig;

    /* Update for UnitDelay: '<S10>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE_e = rtb_Add1;

    /* Update for UnitDelay: '<S11>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE_j = rtb_Add2;

    /* Update for UnitDelay: '<S14>/Unit Delay' */
    MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE_g = rtb_MathFunction2;

    /* Update for UnitDelay: '<S17>/Unit Delay' */
    MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE_j = rtb_Relay;
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The resolution of this integer timer is 0.1, which is the step size
   * of the task. Size of "clockTick0" ensures timer will not overflow during the
   * application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  MiddleRobotCtrl_mat_M->Timing.clockTick0++;
  if (!MiddleRobotCtrl_mat_M->Timing.clockTick0)
    MiddleRobotCtrl_mat_M->Timing.clockTickH0++;
}

/* Model initialize function */
void MiddleRobotCtrl_mat_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* non-finite (run-time) assignments */
  MiddleRobotCtrl_mat_P.Saturation_UpperSat_f = rtInf;

  /* initialize real-time model */
  (void) memset((void *)MiddleRobotCtrl_mat_M,0,
                sizeof(RT_MODEL_MiddleRobotCtrl_mat));

  /* states (dwork) */
  (void) memset((void *)&MiddleRobotCtrl_mat_DWork, 0,
                sizeof(D_Work_MiddleRobotCtrl_mat));

  /* external inputs */
  (void) memset((void *)&MiddleRobotCtrl_mat_U, 0,
                sizeof(ExternalInputs_MiddleRobotCtrl_));

  /* external outputs */
  (void) memset((void *)&MiddleRobotCtrl_mat_Y, 0,
                sizeof(ExternalOutputs_MiddleRobotCtrl));

  {
    int32_T i;

    /* InitializeConditions for S-Function (sfix_udelay): '<S2>/Integer Delay' */
    for (i = 0; i < 5; i++) {
      MiddleRobotCtrl_mat_DWork.IntegerDelay_X[i] =
        MiddleRobotCtrl_mat_P.IntegerDelay_InitialCondition;
    }

    /* InitializeConditions for UnitDelay: '<S6>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE = MiddleRobotCtrl_mat_P.UD_X0;

    /* InitializeConditions for UnitDelay: '<S3>/Unit Delay' */
    MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE =
      MiddleRobotCtrl_mat_P.UnitDelay_X0;

    /* InitializeConditions for UnitDelay: '<S3>/Unit Delay1' */
    MiddleRobotCtrl_mat_DWork.UnitDelay1_DSTATE =
      MiddleRobotCtrl_mat_P.UnitDelay1_X0;

    /* InitializeConditions for UnitDelay: '<S82>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE_p = MiddleRobotCtrl_mat_P.UD_X0_m;

    /* InitializeConditions for UnitDelay: '<S22>/Unit Delay1' */
    MiddleRobotCtrl_mat_DWork.UnitDelay1_DSTATE_i =
      MiddleRobotCtrl_mat_P.UnitDelay1_X0_i;

    /* InitializeConditions for UnitDelay: '<S10>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE_e = MiddleRobotCtrl_mat_P.UD_X0_g;

    /* InitializeConditions for UnitDelay: '<S11>/UD' */
    MiddleRobotCtrl_mat_DWork.UD_DSTATE_j = MiddleRobotCtrl_mat_P.UD_X0_o;

    /* InitializeConditions for UnitDelay: '<S14>/Unit Delay' */
    MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE_g =
      MiddleRobotCtrl_mat_P.UnitDelay_X0_o;

    /* InitializeConditions for UnitDelay: '<S17>/Unit Delay' */
    MiddleRobotCtrl_mat_DWork.UnitDelay_DSTATE_j =
      MiddleRobotCtrl_mat_P.UnitDelay_X0_m;
  }
}

/* Model terminate function */
void MiddleRobotCtrl_mat_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for Real-Time Workshop generated code.
 *
 * [EOF]
 */
