// -*- C++ -*-
/*!
 * @file  MMIM_dmy.cpp
 * @brief dummy module for MMIM
 * @date $Date$
 *
 * $Id$
 */

#include "MMIM_dmy.h"

// Module specification
// <rtc-template block="module_spec">
static const char* mmim_dmy_spec[] =
  {
    "implementation_id", "MMIM_dmy",
    "type_name",         "MMIM_dmy",
    "description",       "dummy module for MMIM",
    "version",           "1.0.0",
    "vendor",            "TMU",
    "category",          "dummy",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "0",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
MMIM_dmy::MMIM_dmy(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_MMIM_outOut("MMIM_out", m_MMIM_out)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
MMIM_dmy::~MMIM_dmy()
{
}



RTC::ReturnCode_t MMIM_dmy::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  addOutPort("MMIM_out", m_MMIM_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t MMIM_dmy::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MMIM_dmy::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MMIM_dmy::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t MMIM_dmy::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t MMIM_dmy::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t MMIM_dmy::onExecute(RTC::UniqueId ec_id)
{
	std::cout<<"please input MMIM command"<<std::endl;
	std::cout<<"1:Start Clean up   0:Stop"<<std::endl;
	std::cin>>m_MMIM_out.data;
	
	if(!m_MMIM_outOut.write()){
		DataPortStatusList stat = m_MMIM_outOut.getStatusList();
		for(size_t i(0), len(stat.size());i<len;++i){
			if(stat[i] != true){
				std::cout<<"Error in connector number"<<i<<std::endl;
			}
		}
	}
	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t MMIM_dmy::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MMIM_dmy::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MMIM_dmy::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MMIM_dmy::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MMIM_dmy::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void MMIM_dmyInit(RTC::Manager* manager)
  {
    coil::Properties profile(mmim_dmy_spec);
    manager->registerFactory(profile,
                             RTC::Create<MMIM_dmy>,
                             RTC::Delete<MMIM_dmy>);
  }
  
};


