// -*- C++ -*-
/*!
 * @file  SamplePlanner.cpp * @brief sample planner component * $Date$ 
 *
 * $Id$ 
 */
#include "SamplePlanner.h"

int p_num;

// Module specification
// <rtc-template block="module_spec">
static const char* sampleplanner_spec[] =
  {
    "implementation_id", "SamplePlanner",
    "type_name",         "SamplePlanner",
    "description",       "sample planner component",
    "version",           "1.0",
    "vendor",            "Junichiro Ooga, TOSHIBA",
    "category",          "RobotPlanner",
    "activity_type",     "SPORADIC",
    "kind",              "DataFowComponent",
    "max_instance",      "0",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    ""
  };
// </rtc-template>

void *keyIn(void *args){

  int num;
  
  do{
    num = 100;
    cout << "Please input command number !" << endl;
    cin >> num;
    p_num = num;
    // cout << "Send command " << m_cmd.data[0] << endl;  

  }while(num < 0 || num > 2);

  cout << "Finish keyIn !" << endl;
  
  return NULL;
}

SamplePlanner::SamplePlanner(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_returnIn("return", m_return),
    m_cmdOut("cmd", m_cmd)

    // </rtc-template>
{
}

SamplePlanner::~SamplePlanner()
{
}



RTC::ReturnCode_t SamplePlanner::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("return", m_returnIn);

  // Set OutPort buffer
  addOutPort("cmd", m_cmdOut);

  // Set service provider to Ports

  // Set service consumers to Ports

  // Set CORBA Service Ports

  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable

  // </rtc-template>

  m_cmd.data.length(10);
  m_cmd.data[0] = 0;

  cout << "finish onInitialize !" << endl;  
  return RTC::RTC_OK;
}



RTC::ReturnCode_t SamplePlanner::onFinalize()
{
  cout << "finish onFinalize !" << endl;
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t SamplePlanner::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t SamplePlanner::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t SamplePlanner::onActivated(RTC::UniqueId ec_id)
{

  // create thread for input console
  //  pthread_create(&th_cin, NULL, keyIn, (void*)1);
  
  cout << "finish onActivated !" << endl;  
  return RTC::RTC_OK;
}


RTC::ReturnCode_t SamplePlanner::onDeactivated(RTC::UniqueId ec_id)
{
  //  pthread_join(th_cin, NULL);
  
  cout << "finish onDeActivated !" << endl;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t SamplePlanner::onExecute(RTC::UniqueId ec_id)
{

  cout << "Please input command... " << endl;
  cout << "1: Object position   2: Hand width " << endl;
  cin >> p_num;
  
  m_cmd.data[0] = p_num;

  switch(p_num){
  case 1:
    cout << "Please input position data...(ID, x, y, z, h, diameter, dish_flag)" << endl;
    // ID, x, y, z, 高さ，直径，食器有無フラグ
    for(int i=0; i<7; i++){
      cin >> m_cmd.data[i];
    }
    cout << "Send position data [";
    for(int i=0; i<7; i++){
      cout << m_cmd.data[i]<<", ";
    }
    cout << "]" << endl;
    break;
  case 2:
    cout << "Please input hand position data[%]..." << endl;
    cin >> m_cmd.data[1];
    cout << "Send hand position data ";
    cout << m_cmd.data[1]<< "[%]" << endl;
    break;
  default:
    //    cout << "[Error] Wrong command number !" << m_cmd.data[0] << endl;
    if(!m_returnIn.isNew()){
      return RTC::RTC_OK;
    }
    cout << "debug" << endl;
    
    m_returnIn.read();  // read Inport
    
    if(m_return.data[0]==0){
      cout << "[OK] Command execution succeeded !" << endl;
    }else{
      cout << "[Error] RETURN ID is " << m_return.data[0] << endl;
    }
    //    pthread_create(&th_cin, NULL, keyIn, (void*)1);
    return RTC::RTC_OK;
  }

  m_cmdOut.write();


  
  // if(!m_returnIn.isNew()){
  //   return RTC::RTC_OK;
  // }
  // cout << "debug" << endl;

  // m_returnIn.read();  // read Inport

  // if(m_return.data[0]==0){
  //   cout << "[OK] Command execution succeeded !" << endl;
  // }else{
  //   cout << "[Error] RETURN ID is " << m_return.data[0] << endl;
  // }  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t SamplePlanner::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t SamplePlanner::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t SamplePlanner::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t SamplePlanner::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t SamplePlanner::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


extern "C"
{
 
  void SamplePlannerInit(RTC::Manager* manager)
  {
    coil::Properties profile(sampleplanner_spec);
    manager->registerFactory(profile,
                             RTC::Create<SamplePlanner>,
                             RTC::Delete<SamplePlanner>);
  }
  
};



